"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DnDBasicDropZone = void 0;
const useI18n_1 = __importDefault(require("@thatweb/core-i18n/hooks/useI18n"));
const SXDiv_1 = __importDefault(require("@thatweb/core-mui/components/sx/SXDiv"));
const TypoBody1_1 = __importDefault(require("@thatweb/core-mui/components/typo/TypoBody1"));
const usePalette_1 = __importDefault(require("@thatweb/core-mui/hooks/usePalette"));
const useSXStyle_1 = __importDefault(require("@thatweb/core-mui/hooks/useSXStyle"));
const react_1 = __importDefault(require("react"));
const DnDSortableController_1 = require("../controllers/DnDSortableController");
exports.default = DnDBasicDropZone;
function DnDBasicDropZone(props) {
    const rowHeight = (0, DnDSortableController_1.useDnDSortableRowHeight)();
    const i18n = (0, useI18n_1.default)();
    const { fullWidth = false, sx = {}, label = i18n.raw('move-here') } = props;
    const p = (0, usePalette_1.default)();
    const sxStyle = (0, useSXStyle_1.default)(() => ({
        sx: Object.assign({ borderRadius: 2, background: p.common.white, border: `1px solid ${p.secondary.main}`, width: fullWidth ? '100%' : 'fit-content', height: 'fit-content', '& .DropZoneLabel': {
                pl: 2,
                width: fullWidth ? 'calc(100% - 2px)' : 240 - 2,
                height: rowHeight - 6,
                lineHeight: `${rowHeight - 6}px`,
                background: p.secondary.shades.p16,
                color: p.secondary.main,
                display: 'block',
            } }, sx),
    }), [p, fullWidth, rowHeight, sx]);
    return (react_1.default.createElement(SXDiv_1.default, Object.assign({}, sxStyle),
        react_1.default.createElement(TypoBody1_1.default, { className: "DropZoneLabel" }, label)));
}
exports.DnDBasicDropZone = DnDBasicDropZone;
//# sourceMappingURL=DnDBasicDropZone.js.map