"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DnDDraggable = void 0;
const useMouseMove_1 = __importDefault(require("@thatreact/core-hooks/hooks/useMouseMove"));
const SXDiv_1 = __importDefault(require("@thatweb/core-mui/components/sx/SXDiv"));
const standardTransitions_1 = __importDefault(require("@thatweb/core-mui/constants/standardTransitions"));
const useSXStyle_1 = __importDefault(require("@thatweb/core-mui/hooks/useSXStyle"));
const react_1 = __importStar(require("react"));
const DnDController_1 = require("../controllers/DnDController");
exports.default = DnDDraggable;
function DnDDraggable(props) {
    const { dragItem, onDragStart, onDragStop } = props;
    const dndReady = (0, DnDController_1.useDnDReady)();
    const { dragHandleClass } = (0, DnDController_1.useDnDOptions)();
    const isDragging = (0, DnDController_1.useDnDIsDragging)(dragItem === null || dragItem === void 0 ? void 0 : dragItem.dragId);
    const isDisabled = dragItem === null || dragItem === void 0 ? void 0 : dragItem.disabled;
    const { x, y } = (0, DnDController_1.useDnDPosition)();
    const { doStart, doMove, doStop } = (0, DnDController_1.useDnDActions)();
    const draggerEl = (0, react_1.useRef)();
    const onStart = (0, react_1.useCallback)(() => {
        doStart(dragItem, draggerEl.current);
        onDragStart === null || onDragStart === void 0 ? void 0 : onDragStart();
    }, [doStart, dragItem, onDragStart]);
    const onStop = (0, react_1.useCallback)(() => {
        doStop();
        onDragStop === null || onDragStop === void 0 ? void 0 : onDragStop();
    }, [doStop, onDragStop]);
    const { handleMouseDown } = (0, useMouseMove_1.default)({
        onStart,
        onMove: doMove,
        onStop: onStop,
        targetClass: dragHandleClass,
        disabled: isDisabled,
    });
    const sxStyle = (0, useSXStyle_1.default)(() => ({
        sx: {
            cursor: 'grabbing',
            position: 'absolute',
            transition: standardTransitions_1.default,
            pointerEvents: 'none',
            zIndex: 1300,
            opacity: 0,
        },
        style: {
            top: isDragging ? y : 0,
            left: isDragging ? x : 0,
        },
    }), [isDragging, y, x]);
    const draggableClassName = (0, react_1.useMemo)(() => ['DnDDraggable', isDragging ? 'dragging' : '', isDisabled ? 'disabled' : ''].join(' '), [isDragging, isDisabled]);
    const positionableClassName = (0, react_1.useMemo)(() => ['DnDPositionable', isDragging ? 'dragged' : ''].join(' '), [isDragging]);
    return (0, react_1.useMemo)(() => {
        var _a;
        if (!dndReady || !dragItem)
            return null;
        return (react_1.default.createElement(SXDiv_1.default, { className: draggableClassName, sx: { position: 'relative' }, onMouseDown: handleMouseDown },
            react_1.default.createElement(SXDiv_1.default, { className: "DnDFromBox" }, dragItem.el),
            react_1.default.createElement(SXDiv_1.default, Object.assign({ ref: draggerEl, className: positionableClassName }, sxStyle), (_a = dragItem.dragEl) !== null && _a !== void 0 ? _a : dragItem.el)));
    }, [dndReady, draggableClassName, handleMouseDown, dragItem, positionableClassName, sxStyle]);
}
exports.DnDDraggable = DnDDraggable;
//# sourceMappingURL=DnDDraggable.js.map