"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DnDDroppable = void 0;
const SXDiv_1 = __importDefault(require("@thatweb/core-mui/components/sx/SXDiv"));
const useSXStyle_1 = __importDefault(require("@thatweb/core-mui/hooks/useSXStyle"));
const react_1 = __importStar(require("react"));
const DnDController_1 = require("../controllers/DnDController");
function DnDDroppable(props) {
    const { children, full = false, sx = {}, style = {}, dropZone, className = '', pullZoneClass, } = props;
    const dndReady = (0, DnDController_1.useDnDReady)();
    const dragItem = (0, DnDController_1.useDnDDragItem)();
    const { doSetDropZone } = (0, DnDController_1.useDnDActions)();
    const isDragging = (0, DnDController_1.useDnDIsDragging)();
    const isDropping = (0, DnDController_1.useDnDIsDropping)(dropZone.id);
    const dropZoneEl = (0, react_1.useRef)();
    const handleMouseEnter = (0, react_1.useCallback)(e => {
        if (!isDragging)
            return;
        if (typeof dropZone.canDrop === 'function' && !dropZone.canDrop(dragItem))
            return;
        if (typeof dropZone.canDrop === 'boolean' && !dropZone.canDrop)
            return;
        doSetDropZone(dropZone, dropZoneEl.current, pullZoneClass);
        e.stopPropagation();
    }, [isDragging, dropZone, dragItem, doSetDropZone, pullZoneClass]);
    const handleMouseLeave = (0, react_1.useCallback)(e => {
        if (!isDragging || !isDropping)
            return;
        doSetDropZone(undefined);
        e.stopPropagation();
    }, [isDragging, isDropping, doSetDropZone]);
    const sxStyle = (0, useSXStyle_1.default)(() => ({
        sx: Object.assign({ width: full ? '100%' : undefined, height: full ? '100%' : undefined }, sx),
        style,
    }), [full, sx, style]);
    return (0, react_1.useMemo)(() => {
        if (!dndReady)
            return null;
        return (react_1.default.createElement(SXDiv_1.default, Object.assign({ ref: dropZoneEl }, sxStyle, { className: `DnDDroppable ${className}`, onMouseEnter: handleMouseEnter, onMouseLeave: handleMouseLeave }), children));
    }, [dndReady, sxStyle, handleMouseEnter, handleMouseLeave, children]);
}
exports.DnDDroppable = DnDDroppable;
exports.default = DnDDroppable;
//# sourceMappingURL=DnDDroppable.js.map