import CtrlState from '@thatreact/ctrl/types/CtrlState';
import XY from '@thats/utils/types/XY';
import React, { MutableRefObject } from 'react';
import DnDDragItem from '../types/DnDDragItem';
import DnDDropZone from '../types/DnDDropZone';
import DnDOptions from '../types/DnDOptions';
export default DnDController;
export interface DnDControllerProps {
    children: any;
    options?: DnDOptions;
}
export declare function DnDController({ children, options, }: DnDControllerProps): React.JSX.Element;
export interface DnDData {
    dndReady: boolean;
    options: DnDOptions;
    dragItem?: DnDDragItem;
    dragItemPosition: XY;
    dragItemPositionRaw: XY;
    dropZone?: DnDDropZone;
    dropZonePosition: XY;
}
export type DnDState = CtrlState<DnDData>;
export declare const DnDContext: React.Context<DnDData>;
export interface DnDActions {
    doSetDropZone: (item: DnDDropZone, dropZoneEl?: HTMLElement, pullZoneClass?: string) => void;
    doStart: (dragItem: DnDDragItem, draggerEl: HTMLDivElement) => void;
    doStop: () => void;
    doMove: (by: XY, start: XY, last: XY, targetOffset: XY) => void;
    doSetPosition: (id: string, position: XY, andRaw?: boolean) => void;
}
export type DnDActionsState = MutableRefObject<DnDActions>;
export declare const DnDActionsContext: React.Context<DnDActions>;
export declare const useDnDActions: () => DnDActions;
export declare const useDnDReady: () => boolean;
export declare const useDnDPosition: () => XY;
export declare const useDnDOptions: () => DnDOptions;
export declare const useDnDDragItem: <T extends DnDDragItem<any>>() => T;
export declare const useDnDIsDragging: (ids?: string | string[]) => false | DnDDragItem;
export declare const useDnDIsDropping: (id?: string) => boolean;
