"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useDnDIsDropping = exports.useDnDIsDragging = exports.useDnDDragItem = exports.useDnDOptions = exports.useDnDPosition = exports.useDnDReady = exports.useDnDActions = exports.DnDActionsContext = exports.DnDContext = exports.DnDController = void 0;
const useCtrlActionsCtx_1 = __importDefault(require("@thatreact/ctrl/hooks/useCtrlActionsCtx"));
const useCtrlCtx_1 = __importDefault(require("@thatreact/ctrl/hooks/useCtrlCtx"));
const useCtrlState_1 = __importDefault(require("@thatreact/ctrl/hooks/useCtrlState"));
const XY_1 = require("@thats/utils/types/XY");
const Col_1 = __importDefault(require("@thatweb/core-mui/components/Col"));
const standardTransitions_1 = __importDefault(require("@thatweb/core-mui/constants/standardTransitions"));
const useSXStyle_1 = __importDefault(require("@thatweb/core-mui/hooks/useSXStyle"));
const react_1 = __importStar(require("react"));
const useDnDDoMove_1 = __importDefault(require("./actions/useDnDDoMove"));
const useDnDDoSetDropZone_1 = __importDefault(require("./actions/useDnDDoSetDropZone"));
const useDnDDoSetPosition_1 = __importDefault(require("./actions/useDnDDoSetPosition"));
const useDnDDoStart_1 = __importDefault(require("./actions/useDnDDoStart"));
const useDnDDoStop_1 = __importDefault(require("./actions/useDnDDoStop"));
const useDnDEffects_1 = __importDefault(require("./actions/useDnDEffects"));
exports.default = DnDController;
function DnDController({ children, options = {
    zeroOnDragStop: true,
    dragHandleClass: 'DnDDraggable',
}, }) {
    const _s = (0, useCtrlState_1.default)({
        dndReady: false,
        options,
        dragItemPosition: (0, XY_1.XYZero)(),
        dragItemPositionRaw: (0, XY_1.XYZero)(),
        dropZonePosition: (0, XY_1.XYZero)(),
    });
    const _a = (0, react_1.useRef)({});
    _a.current.doSetPosition = (0, useDnDDoSetPosition_1.default)(_s, _a);
    _a.current.doSetDropZone = (0, useDnDDoSetDropZone_1.default)(_s, _a);
    _a.current.doStart = (0, useDnDDoStart_1.default)(_s, _a);
    _a.current.doMove = (0, useDnDDoMove_1.default)(_s, _a);
    _a.current.doStop = (0, useDnDDoStop_1.default)(_s, _a);
    (0, useDnDEffects_1.default)(_s, _a);
    const ctx = (0, useCtrlCtx_1.default)(_s);
    const actionsCtx = (0, useCtrlActionsCtx_1.default)(_a, 'DnD');
    const sxStyle = (0, useSXStyle_1.default)(() => ({
        sx: Object.assign(Object.assign({}, (options.dragHandleClass === 'DnDDraggable'
            ? {
                '& .DnDDraggable': { cursor: 'grab', userSelect: 'none' },
                '& .DnDDraggable.disabled': { cursor: 'default' },
            }
            : {
                '& .DnDDraggable': { userSelect: 'none' },
                [`& .DnDDraggable .${options.dragHandleClass}`]: { cursor: 'grab' },
                [`& .DnDDraggable.disabled .${options.dragHandleClass}`]: {
                    cursor: 'default',
                },
            })), { '& .DnDFromBox': { display: 'block', transition: standardTransitions_1.default }, '& .DnDFromBox.DnDDragBox': { display: 'block' }, '& .dragging': {
                '& .DnDFromBox': { opacity: 0.5 },
                '& .DnDFromBox.DnDDragBox': { opacity: 1 },
            } }),
    }), [options]);
    return (react_1.default.createElement(exports.DnDContext.Provider, { value: ctx },
        react_1.default.createElement(exports.DnDActionsContext.Provider, { value: actionsCtx },
            react_1.default.createElement(Col_1.default, Object.assign({ fullWidth: true }, sxStyle), children))));
}
exports.DnDController = DnDController;
exports.DnDContext = react_1.default.createContext(null);
exports.DnDActionsContext = react_1.default.createContext(null);
const useDnDActions = () => (0, react_1.useContext)(exports.DnDActionsContext);
exports.useDnDActions = useDnDActions;
const useDnDReady = () => {
    const { dndReady } = (0, react_1.useContext)(exports.DnDContext);
    return (0, react_1.useMemo)(() => dndReady, [dndReady]);
};
exports.useDnDReady = useDnDReady;
const useDnDPosition = () => {
    const { dragItemPosition } = (0, react_1.useContext)(exports.DnDContext);
    return (0, react_1.useMemo)(() => dragItemPosition !== null && dragItemPosition !== void 0 ? dragItemPosition : (0, XY_1.XYZero)(), [dragItemPosition]);
};
exports.useDnDPosition = useDnDPosition;
const useDnDOptions = () => {
    const { options } = (0, react_1.useContext)(exports.DnDContext);
    return (0, react_1.useMemo)(() => options, [options]);
};
exports.useDnDOptions = useDnDOptions;
const useDnDDragItem = () => {
    const { dragItem } = (0, react_1.useContext)(exports.DnDContext);
    return (0, react_1.useMemo)(() => dragItem, [dragItem]);
};
exports.useDnDDragItem = useDnDDragItem;
const useDnDIsDragging = (ids) => {
    const { dragItem } = (0, react_1.useContext)(exports.DnDContext);
    if (!dragItem)
        return false;
    const isDragging = Array.isArray(ids)
        ? ids.indexOf(dragItem.dragId) >= 0
        : !!ids
            ? dragItem.dragId === ids
            : !!dragItem.dragId;
    return isDragging ? dragItem : false;
};
exports.useDnDIsDragging = useDnDIsDragging;
const useDnDIsDropping = (id) => {
    const { dropZone } = (0, react_1.useContext)(exports.DnDContext);
    return id ? (dropZone === null || dropZone === void 0 ? void 0 : dropZone.id) === id : !!dropZone;
};
exports.useDnDIsDropping = useDnDIsDropping;
//# sourceMappingURL=DnDController.js.map