import CtrlState from '@thatreact/ctrl/types/CtrlState';
import React, { MouseEvent, MutableRefObject, ReactElement } from 'react';
import DnDDragItem from '../types/DnDDragItem';
export default DnDSortableController;
export interface DnDSortableControllerProps<T extends {
    id: string;
}> {
    children: any;
    horizontal?: boolean;
    disabled?: boolean;
    listId?: string;
    depth?: number;
    rowHeight?: number;
    items?: T[];
    renderItem?: (item: T, idx: number, groupSizeAdjustment?: number) => ReactElement;
    renderDropZone?: (idx: number, groupSizeAdjustment?: number) => ReactElement;
    onDrop: (item: T, idx: number) => void;
}
export declare function DnDSortableController<T extends {
    id: string;
}>(props: DnDSortableControllerProps<T>): React.JSX.Element;
export interface DnDSortableData<T extends {
    id: string;
} = {
    id: string;
}> extends Omit<DnDSortableControllerProps<T>, 'children'> {
    dropZoneIdx?: number;
    active?: boolean;
    enterTimeout?: any;
}
export type DnDSortableState = CtrlState<DnDSortableData>;
export declare const DnDSortableContext: React.Context<DnDSortableData<{
    id: string;
}>>;
export interface DnDSortableActions<T extends {
    id: string;
} = {
    id: string;
}> {
    _placeDropZone: (idx: number) => void;
    doRenderItem: (item: T, idx: number) => ReactElement;
    doMouseEnter: (e: MouseEvent) => void;
    doMouseLeave: (e: MouseEvent) => void;
    doMouseMove: (e: MouseEvent) => void;
    doDrop: (item: DnDDragItem) => void;
    doLoseControl: () => void;
    doTakeControlFrom: (id: string) => void;
}
export type DnDSortableActionsState = MutableRefObject<DnDSortableActions>;
export declare const DnDSortableActionsContext: React.Context<DnDSortableActions<{
    id: string;
}>>;
export declare const useDnDSortableActions: () => DnDSortableActions<{
    id: string;
}>;
export declare function useDnDSortableItems(): {
    id: string;
}[];
export declare function useDnDSortableDisabled(): boolean;
export declare function useDnDSortableDepth(): number;
export declare function useDnDSortableRowHeight(): number;
export declare function useDnDSortableActive(): boolean;
