"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useDnDDoMove = void 0;
const XY_1 = require("@thats/utils/types/XY");
const addXY_1 = __importDefault(require("@thats/utils/xy/addXY"));
const snapXY_1 = __importDefault(require("@thats/utils/xy/snapXY"));
const subtractXY_1 = __importDefault(require("@thats/utils/xy/subtractXY"));
const react_1 = require("react");
exports.default = useDnDDoMove;
function useDnDDoMove({ current: _s }, { current: _a }) {
    return (0, react_1.useCallback)((by, start, last, targetOffset) => {
        var _b, _c;
        _s.dropZonePosition = (0, addXY_1.default)(last, targetOffset);
        const { id } = _s.dragItem.data;
        const raw = (_b = _s.dragItemPositionRaw) !== null && _b !== void 0 ? _b : (0, XY_1.XYZero)();
        const pos = (_c = _s.dragItemPosition) !== null && _c !== void 0 ? _c : (0, XY_1.XYZero)();
        if (!id)
            return;
        const newRaw = (0, addXY_1.default)(raw, by);
        _s.dragItemPositionRaw = newRaw;
        const newSnapped = _s.options.snapToGridSize && _s.options.snapToGridSize !== 1
            ? (0, snapXY_1.default)(newRaw, _s.options.snapToGridSize)
            : newRaw;
        const snappedBy = (0, subtractXY_1.default)(newSnapped, pos);
        if (snappedBy.x || snappedBy.y) {
            _a.doSetPosition(id, (0, addXY_1.default)(pos, snappedBy));
        }
    }, [_s, _a]);
}
exports.useDnDDoMove = useDnDDoMove;
//# sourceMappingURL=useDnDDoMove.js.map