"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useDnDDoSetDropZone = void 0;
const useDebounce_1 = require("@thatreact/core-hooks/hooks/useDebounce");
exports.default = useDnDDoSetDropZone;
function useDnDDoSetDropZone({ current: _s }, { current: _a }) {
    return (0, useDebounce_1.useDebounce100)((dropZone, dropZoneEl, pullZoneClass) => {
        if (_s.dragItem) {
            const draggerEl = _s.dragItem._draggerEl;
            let currentParent = draggerEl.parentElement;
            if (draggerEl.parentElement !== document.body) {
                const newParent = document.body;
                currentParent.className = currentParent.className.split(' dropping').join('');
                currentParent.removeChild(draggerEl);
                draggerEl.style.position = 'absolute';
                newParent.appendChild(draggerEl);
                currentParent = newParent;
            }
            if (pullZoneClass && dropZoneEl) {
                const newParent = dropZoneEl.querySelector(`.${pullZoneClass}`);
                currentParent.removeChild(draggerEl);
                draggerEl.style.position = 'relative';
                newParent.className += ' dropping';
                newParent.appendChild(draggerEl);
            }
        }
        _s.dropZone = dropZone;
        _s.setChanged();
    }, [_s]);
}
exports.useDnDDoSetDropZone = useDnDDoSetDropZone;
//# sourceMappingURL=useDnDDoSetDropZone.js.map