"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useDnDDoStart = void 0;
const react_1 = require("react");
exports.default = useDnDDoStart;
function useDnDDoStart({ current: _s }, { current: _a }) {
    return (0, react_1.useCallback)((dragItem, draggerEl) => {
        if (dragItem.disabled)
            return;
        _s.dragItem = dragItem;
        dragItem._draggerEl = draggerEl;
        dragItem._draggerParentEl = draggerEl.parentElement;
        const { top: y, left: x } = draggerEl.getBoundingClientRect();
        _s.dragItemPositionRaw = { x, y };
        draggerEl.parentElement.removeChild(draggerEl);
        draggerEl.style.top = `${y}px`;
        draggerEl.style.bottom = `${x}px`;
        draggerEl.style.opacity = '1';
        document.body.appendChild(draggerEl);
        const h = _s.options.hideOnDragStart;
        if (_s.options.hideOnDragStart || dragItem.hideOnDragStart) {
            dragItem._draggerParentEl.style.display = 'none';
        }
        _s.setChanged();
    }, [_s]);
}
exports.useDnDDoStart = useDnDDoStart;
//# sourceMappingURL=useDnDDoStart.js.map