"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useDnDDoStop = void 0;
const XY_1 = require("@thats/utils/types/XY");
const react_1 = require("react");
exports.default = useDnDDoStop;
function useDnDDoStop({ current: _s }, { current: _a }) {
    return (0, react_1.useCallback)(() => {
        var _b, _c;
        if (!_s.dragItem)
            return;
        const { id } = _s.dragItem.data;
        if (_s.dropZone)
            (_c = (_b = _s.dropZone).onDrop) === null || _c === void 0 ? void 0 : _c.call(_b, _s.dragItem, _s.dropZonePosition);
        if (_s.options.zeroOnDragStop || _s.dragItem.zeroOnDragStop)
            _a.doSetPosition(id, (0, XY_1.XYZero)(), true);
        const draggerEl = _s.dragItem._draggerEl;
        const originalParent = _s.dragItem._draggerParentEl;
        const currentParent = draggerEl.parentElement;
        currentParent.removeChild(draggerEl);
        currentParent.className = currentParent.className.split(' dropping').join('');
        draggerEl.style.opacity = '0';
        draggerEl.style.position = 'absolute';
        originalParent.appendChild(draggerEl);
        if (_s.options.hideOnDragStart || _s.dragItem.hideOnDragStart) {
            originalParent.style.display = 'initial';
        }
        _s.dragItem = undefined;
        _s.dropZonePosition = undefined;
        _s.setChanged();
    }, [_s, _a]);
}
exports.useDnDDoStop = useDnDDoStop;
//# sourceMappingURL=useDnDDoStop.js.map