"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useDnDSortableDoMouseEnter = void 0;
const useAsRef_1 = __importDefault(require("@thatreact/core-hooks/hooks/useAsRef"));
const react_1 = require("react");
const DnDController_1 = require("../DnDController");
const DnDSortableController_1 = require("../DnDSortableController");
exports.default = useDnDSortableDoMouseEnter;
function useDnDSortableDoMouseEnter({ current: _s }, { current: _a }) {
    const parentActions = (0, DnDSortableController_1.useDnDSortableActions)();
    const isDragging = (0, useAsRef_1.default)((0, DnDController_1.useDnDIsDragging)());
    const { doSetDropZone } = (0, DnDController_1.useDnDActions)();
    return (0, react_1.useCallback)((e) => {
        var _b, _c, _d;
        (_b = parentActions === null || parentActions === void 0 ? void 0 : parentActions.doLoseControl) === null || _b === void 0 ? void 0 : _b.call(parentActions);
        doSetDropZone({ id: _s.listId, onDrop: _a.doDrop });
        if (isDragging.current) {
            const { top: y, height: h } = e.target.getBoundingClientRect();
            const { clientY: mY } = e;
            const dY = mY - y;
            const enteredInTopHalfOfSortable = dY < h / 2;
            if (enteredInTopHalfOfSortable) {
                _a._placeDropZone(0);
            }
            else {
                _a._placeDropZone((_d = (_c = _s.items) === null || _c === void 0 ? void 0 : _c.length) !== null && _d !== void 0 ? _d : 0);
            }
            _s.enterTimeout = setTimeout(() => {
                _s.active = true;
                _s.setChanged();
            }, 100);
        }
    }, [_s, _a, parentActions, isDragging, doSetDropZone]);
}
exports.useDnDSortableDoMouseEnter = useDnDSortableDoMouseEnter;
//# sourceMappingURL=useDnDSortableDoMouseEnter.js.map