"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useDnDSortableDoMouseMove = void 0;
const useAsRef_1 = __importDefault(require("@thatreact/core-hooks/hooks/useAsRef"));
const react_1 = require("react");
const DnDController_1 = require("../DnDController");
exports.default = useDnDSortableDoMouseMove;
function useDnDSortableDoMouseMove({ current: _s }, { current: _a }) {
    const isDragging = (0, useAsRef_1.default)((0, DnDController_1.useDnDIsDragging)());
    const dragItem = (0, useAsRef_1.default)((0, DnDController_1.useDnDDragItem)());
    return (0, react_1.useCallback)((e) => {
        if (isDragging.current && _s.active) {
            const el = e.target.closest('.DnDSortableItem');
            const { top: overY, height: overHeight } = el.getBoundingClientRect();
            const { clientY: mouseY } = e;
            if (mouseY < overY + _s.rowHeight * 0.75) {
                _a._placeDropZone(parseInt(el.dataset.idx));
            }
            else if (mouseY > overY + overHeight - _s.rowHeight * 0.75) {
                _a._placeDropZone(parseInt(el.dataset.idx) + 1);
            }
        }
    }, [_s, _a, isDragging, dragItem]);
}
exports.useDnDSortableDoMouseMove = useDnDSortableDoMouseMove;
//# sourceMappingURL=useDnDSortableDoMouseMove.js.map