"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useDnDSortableDoRenderItem = void 0;
const useAsRef_1 = __importDefault(require("@thatreact/core-hooks/hooks/useAsRef"));
const SXDiv_1 = __importDefault(require("@thatweb/core-mui/components/sx/SXDiv"));
const react_1 = __importStar(require("react"));
const consts_1 = require("../../constants/consts");
const DnDController_1 = require("../DnDController");
exports.default = useDnDSortableDoRenderItem;
function useDnDSortableDoRenderItem({ current: _s }, { current: _a }) {
    const dragItem = (0, useAsRef_1.default)((0, DnDController_1.useDnDDragItem)());
    return (0, react_1.useCallback)((item, idx) => {
        var _b, _c, _d, _e, _f, _g;
        const indentMargin = 0;
        const dragItemIdx = (_c = (_b = _s.items) === null || _b === void 0 ? void 0 : _b.findIndex(i => { var _b; return i.id === ((_b = dragItem.current) === null || _b === void 0 ? void 0 : _b.dragId); })) !== null && _c !== void 0 ? _c : -1;
        const { isAbove, isBelow } = calcAboveBelow(idx, _s.dropZoneIdx, dragItemIdx);
        const className = [
            'DnDSortableItem',
            isAbove ? 'DnDAboveDropZone' : '',
            isBelow ? 'DnDBelowDropZone' : '',
        ].join(' ');
        let groupSizeAdjustment = 0;
        if (_s.active && dragItemIdx === -1)
            groupSizeAdjustment = 1;
        else if (_s.active && dragItemIdx >= 0 && dragItemIdx < idx)
            groupSizeAdjustment = 1;
        else if (!_s.active && dragItemIdx >= 0)
            groupSizeAdjustment = 0;
        if (item.id === consts_1.DnDSortableDropZoneId) {
            return (react_1.default.createElement(SXDiv_1.default, { className: className, key: item.id, "data-id": item.id, "data-idx": idx, sx: {
                    pointerEvents: 'none',
                    ml: `${-indentMargin}px`,
                    mt: `-40px`,
                    pt: '40px',
                }, onMouseMove: _a.doMouseMove }, (_e = (_d = _s.renderDropZone) === null || _d === void 0 ? void 0 : _d.call(_s, idx, groupSizeAdjustment)) !== null && _e !== void 0 ? _e : react_1.default.createElement("div", null)));
        }
        return (react_1.default.createElement(SXDiv_1.default, { className: className, key: item.id, "data-id": item.id, "data-idx": idx, sx: { ml: `${-indentMargin}px` }, onMouseMove: _a.doMouseMove }, (_g = (_f = _s.renderItem) === null || _f === void 0 ? void 0 : _f.call(_s, item, idx, groupSizeAdjustment)) !== null && _g !== void 0 ? _g : react_1.default.createElement("div", null)));
    }, [_s, _a, dragItem]);
}
exports.useDnDSortableDoRenderItem = useDnDSortableDoRenderItem;
function calcAboveBelow(idx, dropZoneIdx, dragItemIdx) {
    let isAboveIdx = dropZoneIdx - 1;
    if (isAboveIdx === dragItemIdx)
        isAboveIdx -= 1;
    let isBelowIdx = dropZoneIdx + 1;
    if (isBelowIdx === dragItemIdx)
        isBelowIdx += 1;
    return { isAbove: idx === isAboveIdx, isBelow: idx === isBelowIdx };
}
//# sourceMappingURL=useDnDSortableDoRenderItem.js.map