"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useDnDSortableEffects = void 0;
const react_1 = require("react");
const DnDController_1 = require("../DnDController");
exports.default = useDnDSortableEffects;
function useDnDSortableEffects({ current: _s }, { current: _a }, props) {
    const dragItem = (0, DnDController_1.useDnDDragItem)();
    const isDragging = (0, DnDController_1.useDnDIsDragging)();
    (0, react_1.useEffect)(() => {
        var _b, _c;
        if (!dragItem)
            return;
        const childIdx = (_c = (_b = _s.items) === null || _b === void 0 ? void 0 : _b.findIndex(i => i.id === dragItem.dragId)) !== null && _c !== void 0 ? _c : -1;
        if (childIdx >= 0) {
            _s.active = true;
            _a._placeDropZone(childIdx);
        }
    }, [_s, _a, dragItem]);
    (0, react_1.useEffect)(() => {
        if (!isDragging) {
            _s.active = false;
            _s.setChanged();
        }
    }, [_s, _a, isDragging]);
    (0, react_1.useEffect)(() => {
        if (_s.items === props.items)
            return;
        _s.items = props.items;
        _s.setChanged();
    }, [_s, props.items]);
    (0, react_1.useEffect)(() => {
        _s.renderItem = props.renderItem;
        _s.renderDropZone = props.renderDropZone;
        _s.onDrop = props.onDrop;
        _s.setChanged();
    }, [_s, props.renderItem, props.renderDropZone, props.onDrop]);
}
exports.useDnDSortableEffects = useDnDSortableEffects;
//# sourceMappingURL=useDnDSortableEffects.js.map