"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useDnDSortablePlaceDropZone = void 0;
const flatten_1 = __importDefault(require("lodash/flatten"));
const react_1 = require("react");
const consts_1 = require("../../constants/consts");
exports.default = useDnDSortablePlaceDropZone;
function useDnDSortablePlaceDropZone({ current: _s }, { current: _a }) {
    return (0, react_1.useCallback)((idx) => {
        var _b, _c;
        if (_s.dropZoneIdx === idx)
            return;
        const itemsWithoutDropZone = (_c = (_b = _s.items) === null || _b === void 0 ? void 0 : _b.filter(i => i.id !== consts_1.DnDSortableDropZoneId)) !== null && _c !== void 0 ? _c : [];
        if (idx === undefined) {
            _s.items = itemsWithoutDropZone;
        }
        else {
            const dropZoneItem = { id: consts_1.DnDSortableDropZoneId };
            _s.items = (0, flatten_1.default)(itemsWithoutDropZone.map((i, iIdx) => (iIdx === idx ? [dropZoneItem, i] : i)));
            if (idx === -1)
                _s.items = [dropZoneItem, ..._s.items];
            if (idx === itemsWithoutDropZone.length)
                _s.items = [..._s.items, dropZoneItem];
        }
        _s.dropZoneIdx = idx;
        _s.setChanged();
    }, [_s]);
}
exports.useDnDSortablePlaceDropZone = useDnDSortablePlaceDropZone;
//# sourceMappingURL=useDnDSortablePlaceDropZone.js.map